package org.eclipse.atf.mozilla.ide.debug.preferences;

import org.eclipse.atf.mozilla.ide.debug.MozillaDebugPlugin;

/*
 * Preference Keys used for JavaScript Debugging
 */
public class JSDebugPreferenceNames {

	private JSDebugPreferenceNames() {}
	
	private final static String PREFIX = MozillaDebugPlugin.ID;
	
	//suspend on first line preference key
	public final static String SUSPEND_ON_FIRST_LINE = PREFIX + "suspend_on_first_line"; //$NON-NLS-1$
	
	//suspend on errors preference key
	public final static String SUSPEND_ON_ERRORS = PREFIX + "suspend_on_errors"; //$NON-NLS-1$
	
	//suspend on exceptions preference key
	public final static String SUSPEND_ON_EXCEPTIONS = PREFIX + "suspend_on_exceptions"; //$NON-NLS-1$
	
	//suspend on "debugger" keyword preference key
	public final static String SUSPEND_ON_DEBUGGER_KEYWORD = PREFIX + "suspend_on_debugger_keyword"; //$NON-NLS-1$
	
	public final static String OVERRIDE_PREFERENCES = PREFIX + "override_preferences";
	
	public final static String RUNTIME_SUSPEND_ERRORS = PREFIX + "runtime_suspend_on_errors";
	
	public final static String RUNTIME_SUSPEND_EXCEPTIONS = PREFIX + "runtime_suspend_on_exceptions";
	
	public final static String RUNTIME_SUSPEND_DEBUGGER = PREFIX + "runtime_suspend_on_debugger_keyword";

}
